=== debian/changelog ===
centrifuge (1.0.3~beta-2) unstable; urgency=medium

  * Move hisat2 and jellyfish to Build-Depends to make sure package builds
    only on those architectures where it can be installed later
  * -msse2 is already enabled by default on amd64 (which is the only
    architecture the package runs anyway)
    Closes: #890378
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Wed, 14 Feb 2018 14:18:27 +0100

centrifuge (1.0.3~beta-1) unstable; urgency=low

  * Initial release (Closes: #886463)

 -- Andreas Tille <tille@debian.org>  Sat, 06 Jan 2018 12:11:48 +0100
