## centrifuge 1.0.3

=== Makefile ===
--- 
+++ 
@@ -191,6 +191,7 @@
 	centrifuge-build \
 	centrifuge-inspect \
 	centrifuge-download \
+	centrifuge-kreport \
 	$(wildcard centrifuge-*.pl)
