=== debian/changelog ===
centrifuge (1.0.3-4) unstable; urgency=medium

  * Team Upload.
  [ Steffen Möller ]
  * Added ref to conda

  [ Nilesh Patra ]
  * Add autopkgtests
  * Remove empty
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Nilesh Patra <npatra974@gmail.com>  Mon, 24 Aug 2020 18:19:52 +0530

centrifuge (1.0.3-3) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #936281
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * use dh-python

 -- Andreas Tille <tille@debian.org>  Tue, 10 Sep 2019 08:20:22 +0200

centrifuge (1.0.3-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/u/metadata:
    - added RRIDs
    - yamllint clean

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Do not report beta versions in watch file
  * Fix Perl interpreter path
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Remove non-helpful docs

 -- Andreas Tille <tille@debian.org>  Mon, 07 Jan 2019 09:25:30 +0100

centrifuge (1.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Andreas Tille <tille@debian.org>  Fri, 02 Mar 2018 19:59:50 +0100
