=== debian/control ===
--- 
+++ 
@@ -3,19 +3,23 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
+               dh-python,
+               dh-sequence-python3,
                hisat2,
                jellyfish
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/centrifuge.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/centrifuge.git
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/centrifuge
+Vcs-Git: https://salsa.debian.org/med-team/centrifuge.git
 Homepage: https://ccb.jhu.edu/software/centrifuge/
+Rules-Requires-Root: no
 
 Package: centrifuge
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python,
+         ${python3:Depends},
+         python3,
          hisat2,
          jellyfish
 Description: rapid and memory-efficient system for classification of DNA sequences
