=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export POPCNT_CAPABILITY=0
 %:
-	dh $@
+	dh $@ --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr/lib/centrifuge
@@ -22,3 +22,11 @@
 	   debian/$(DEB_SOURCE)/usr/share/doc/$(DEB_SOURCE)/html
 	# remove useless stuff in documentation dir
 	rm -rf debian/$(DEB_SOURCE)/usr/lib/centrifuge/share/doc/
+
+override_dh_install:
+	dh_install
+	for pl in `grep -Rl '#![[:space:]]*/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
+	    sed -i '1s?^#![[:space:]]*/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
+	done
+	rm -rf debian/*/usr/lib/centrifuge/share/centrifuge/doc
+	find debian -name manual.inc.html | xargs rm -rf
