=== debian/watch ===
version=4

https://github.com//infphilo/centrifuge/releases .*/archive/v?(\d[.\d]+)@ARCHIVE_EXT@
