## centrifuge 1.0.4.1

=== debian/changelog ===
centrifuge (1.0.4.1-1) unstable; urgency=medium

  * New upstream version 1.0.4.1
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/s/lintian-overrides: flag false positive missing source.
  * no_msse2.patch: unfuzz.
  * fix_auto_ptr_usage_in_gcc-7.patch: delete: applied upstream.
  * 0002-Fix-build-with-rank.patch: apparently not needed anymore.
  * d/copyright: refer to the versioned GPL-3 file.
  * d/salsa-ci.yml: disable i386 builds due to missing dependencies.
  * hardening.patch: also propagate CPPFLAGS.

 -- Étienne Mollier <emollier@debian.org>  Sun, 25 Aug 2024 17:19:30 +0200

centrifuge (1.0.3-12) unstable; urgency=medium

  * Team upload.
  * d/control: stop building on 32-bit architectures.
  * d/{upstream/metadata,copyright,watch}: link to the new repo

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 19 Mar 2024 18:50:22 +0100

centrifuge (1.0.3-11) unstable; urgency=medium

  * Builds reproducibly (thanks for the patch to Vagrant Cascadian)
    Closes: #1021513
  * Standards-Version: 4.6.1 (routine-update)
  * Set upstream metadata fields: Repository-Browse.
  * Lintian-overrides for false positive (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Mon, 10 Oct 2022 07:52:41 +0200

centrifuge (1.0.3-10) unstable; urgency=medium

  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Sun, 05 Dec 2021 21:16:55 +0100

centrifuge (1.0.3-9) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * Fix manpages

 -- Andreas Tille <tille@debian.org>  Tue, 12 Oct 2021 08:43:55 +0200

centrifuge (1.0.3-8) unstable; urgency=medium

  [ Helmut Grohne ]
  * Improve cross building: Don't detect -m64 from uname.
    Closes: #973977

  [ Andreas Tille ]
  * Revert the patch from 1.0.3-6 in favour of above change

 -- Andreas Tille <tille@debian.org>  Mon, 09 Nov 2020 17:36:30 +0100

centrifuge (1.0.3-7) unstable; urgency=medium

  * Fix code to build on arm64

 -- Andreas Tille <tille@debian.org>  Sat, 07 Nov 2020 20:13:11 +0100

centrifuge (1.0.3-6) unstable; urgency=medium

  * Fix patch for other architectures than amd64

 -- Andreas Tille <tille@debian.org>  Sat, 07 Nov 2020 07:26:48 +0100

centrifuge (1.0.3-5) unstable; urgency=medium

  * Enable building on all architectures where jellyfish is available
  * No need to Build-Depend hisat2 since this is available on all
    architectures now.  Jellyfish is the restricting package for builds.
  * Test on all architectures where jellyfish is available

 -- Andreas Tille <tille@debian.org>  Fri, 06 Nov 2020 16:56:30 +0100
