=== debian/changelog ===
centrifuge (1.0.4.2-1) unstable; urgency=medium

  * New upstream version 1.0.4.2

 -- Étienne Mollier <emollier@debian.org>  Mon, 28 Oct 2024 22:52:16 +0100
