=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: centrifuge
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
                dh-python,
                dh-sequence-python3,
-               hisat2,
                jellyfish
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/centrifuge
 Vcs-Git: https://salsa.debian.org/med-team/centrifuge.git
 Homepage: https://ccb.jhu.edu/software/centrifuge/
