=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 export POPCNT_CAPABILITY=0
 %:
 	dh $@ --with python3
+
+override_dh_auto_build:
+	dh_auto_build -- BITS=$(DEB_HOST_ARCH_BITS) BITS_FLAG=
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr/lib/centrifuge
